/*
 * RGBPixel.h
 *
 *      Author: bertini
 */

#ifndef RGBPIXEL_H_
#define RGBPIXEL_H_

class RGBPixel {
public:
	RGBPixel(unsigned char r=0, unsigned char g=0, unsigned char b=0) : R(r), G(g), B(b) {};
	unsigned char getR() const {
		return R;
	}
	void setR(unsigned char R) {
		this->R = R;
	}
	unsigned char getG() const {
		return G;
	}
	void setG(unsigned char G) {
		this->G = G;
	}
	unsigned char getB() const {
		return B;
	}
	void setB(unsigned char B) {
		this->B = B;
	}
	RGBPixel operator+(const RGBPixel& rhp) {
		// TODO implement: if the sum of a channel is >255 set to 255
		// Remind to handle the risk of overflows
	}
	bool operator>(const RGBPixel& rhp) const {
		// TODO implement
		// it's enough that one of the channels is > while the other are ==
	}
	bool operator==(const RGBPixel& rhp) const {
		// TODO implement
	}

private:
	unsigned char R, G, B;
};

#endif /* RGBPIXEL_H_ */
